LeetCode oj 338. Counting Bits(DP)

338. Counting Bits QuestionEditorial Solution My Submissions
Total Accepted: 46702
Total Submissions: 79672
Difficulty: Medium
Given a non negative integer number num. For every numbers i in the range 0 ≤ i ≤ num calculate the number of 1's in their binary representation and return them as an array.

Example:
For num = 5 you should return [0,1,1,2,1,2].

Follow up:

It is very easy to come up with a solution with run time O(n*sizeof(integer)). But can you do it in linear time O(n) /possibly in a single pass?
Space complexity should be O(n).
Can you do it like a boss? Do it without using any builtin function like __builtin_popcount in c++ or in any other language.
输入一个数Num,问从0到Num每个数的二进制表示有多少个1。
第一次做LeetCode上的题,以为这上面的题都是暴力。。。看来想错了= =+,不过也是一道水DP,题目里说有O(n*m)的解法和O(n)的解法,前者很容易想,暴力求1的个数就可以,还可以预处理一下。O(n)的话就是DP了,状态转移方程很好想,dp[i] = dp[i>>1] + i%2;(默默吐槽一句用java写算法果然难受 = =+)
public class Problem338 {
	public static int[] countBits(int num) {
		int count [] = new int[num+1]; 
		for(int i=0;i<=num;i++){
			count[i] = count[i>>1] + i % 2;
		}
		return count;
	}
	public static void main(String [] args){
		int re [] = countBits(8);
		for(int i : re){
			System.out.println(i);
		}
	}
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值